
KLIC1    EQU       8A36h                    ; kl 1 (AX)
KLIC2    EQU       0E63Bh                   ; kl 2 (BX)
KLIC3    EQU       2E64h                    ; kl 3 (CX)
KLIC4    EQU       6AA9h                    ; kl 4 (DX)
KLIC5    EQU       9E62h                    ; kl 5 (BX vstup)

bit0     EQU       1
bit1     EQU       2
bit2     EQU       4
bit3     EQU       8
bit4     EQU       10h
bit5     EQU       20h
bit6     EQU       40h
bit7     EQU       80h

Code     SEGMENT
         ASSUME    cs:Code,ds:Code
         ORG       100h

KORIG    EQU       5ch-103h                 ; korekce adres

Start:   jmp       Init                     ; start a inicializace programu

RezidBeg label     byte                     ; zatek rezidentn sti

Old08    dd        0                        ; pvodn adresa INT 08h
Old09    dd        0                        ; pvodn adresa INT 09h
Old16    dd        0                        ; pvodn adresa INT 16h
Old33    dd        0                        ; pvodn adresa INT 33h (je-li my)

Param    db        bit0                     ; parametry
                                            ;   bit 0: 1=funkce zapnuta
                                            ;   bit 1: 1=displej ztmaven
                                            ;   bit 2: 1=poadovno rozsvcen

                                            ;   bit 5: 1=je ovlada myi
                                            ;   bit 6: 1=poadavek odinstalovn
                                            ;   bit 7: 1=prvn instalace progr.

Timer    dw        0                        ; ta pro ztmaven displeje
Timer0   dw        5*1092                   ; nastaven doba pro ztmavovn

Timer2   db        5*18                     ; ta pro test portem
OldKey   db        0                        ; uschovan stav portu klvesnice
                                            ;   (0=nen)

; -----------------------------------------------------------------------------
;        obsluha INT 09h
; -----------------------------------------------------------------------------

INT09    PROC      FAR

; ------ test, zda je displej ztmaven

         or        byte ptr cs:[Param+KORIG],bit2; poadavek rozsvcen
         test      byte ptr cs:[Param+KORIG],bit1; je displej ztmaven ?
         jnz       INT091                   ; displej je ztmaven
INT090:  jmp       dword ptr cs:[Old09+KORIG]    ; pokraovn v obsluze

; ------ ignorovn klvesy pi rozsvcen displeje

INT091:  pushf
         call      dword ptr cs:[Old09+KORIG]

         push      bx
         push      ds
         xor       bx,bx
         mov       ds,bx
         mov       bx,ds:[41ah]             ; tec adresa z bufferu
         mov       ds:[41ch],bx             ; zruen obsahu bufferu
         pop       ds
         pop       bx
INT099:  iret

INT09    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 08h
; -----------------------------------------------------------------------------

INT08    PROC      FAR

; ------ pvodn obsluha INT 08h

         pushf
         call      dword ptr cs:[Old08+KORIG] ; pvodn obsluha INT 08h

; ------ test, zda je funkce aktivn

         test      byte ptr cs:[Param+KORIG],bit0 ; je funkce aktivn ?
         jz        INT099                   ; funkce nen aktivn

; ------ schova registr

         push      ax
         push      dx
         push      ds

; ------ pprava adresy stavovho portu

         xor       ax,ax                    ; AX <- 0
         mov       ds,ax                    ; DS <- 0
         mov       dx,ds:[463h]             ; bzov dic adresa displeje
         mov       ah,ds:[465h]             ; nastaven portu 3d8h
         add       dl,4                     ; adresa dicho portu displeje
         push      cs
         pop       ds                       ; DS <- CS

; ------ test, zda je poadovno rozsvcen displeje (od myi nebo INT 09h)

         test      byte ptr ds:[Param+KORIG],bit2 ; poadovno rozsvcen ?
         jnz       INT085                   ; je poadovno rozsvcen

; ------ test, zda se bude dlat test pomoc portu

         test      byte ptr ds:[Param+KORIG],bit1 ; je displej ztmaven ?
         jnz       INT081                   ; displej je ztmaven - test vdy
         dec       byte ptr ds:[Timer2+KORIG] ; tn doby pro test
         jnz       INT082                   ; neprovd se test

; ------ test, zda je zmna portu klvesnice

INT081:  in        al,[60h]                 ; ten portu klvesnice
         xchg      al,ds:[OldKey+KORIG]     ; schova nov klvesy
         cmp       al,0                     ; je platn klvesa ?
         je        INT082                   ; zmna se neporovnv
         cmp       al,ds:[OldKey+KORIG]     ; je zmna portu klvesnice ?
         jne       INT086                   ; je zmna - rozsvcen displeje

; ------ optovn ztmaven displeje

INT082:  test      byte ptr ds:[Param+KORIG],bit1 ; je displej ztmaven ?
         jnz       INT084                   ; displej je ztmaven

; ------ tn ztmaven displeje

         dec       word ptr ds:[Timer+KORIG]; tn doby pro ztmaven
         jnz       INT088                   ; nen jet ztmaven
         or        byte ptr ds:[Param+KORIG],bit1 ; pznak ztmaven displeje
         in        al,[60h]                 ; stav portu klvesnice
         mov       ds:[OldKey+KORIG],al     ; schova portu klvesnice

; ------ vypnut videosignlu

INT084:  and       ah,not 8
         mov       al,ah
         out       dx,al                    ; vypnut videosignlu
         inc       dx
         inc       dx
         in        al,dx                    ; synchronizace nslednosti
         mov       dl,0c0h                  ; adresa portu palet
         mov       al,11h                   ; registr barvy okol
         out       dx,al                    ; volba registru barvy okol
         mov       al,0                     ; ern barva
         out       dx,al                    ; nastaven okol na ernou barvu
         jmp       short INT088

; ------ rozsvcen displeje

INT085:  mov       byte ptr ds:[OldKey+KORIG],0  ; zruen klvesy v bufferu
INT086:  test      byte ptr ds:[Param+KORIG],bit1 ; je displej ztmaven ?
         jz        INT087                   ; nen ztmaven

; ------ zapnut videosignlu

         or        ah,8
         mov       al,ah
         out       dx,al                    ; zapnut videosignlu
         inc       dx
         inc       dx
         in        al,dx                    ; synchronizace nslednosti
         mov       dl,0c0h                  ; adresa portu palet
         mov       al,20h
         out       dx,al                    ; zapnut videosignlu

; ------ nov inicializace tae

INT087:  mov       ax,ds:[Timer0+KORIG]     ; inicializan nastaven tae
         mov       ds:[Timer+KORIG],ax      ; nov nastaven tae
         and       byte ptr ds:[Param+KORIG],not bit1+bit2 ; zruen pznak
         mov       byte ptr ds:[Timer2+KORIG],5*18 ; ta pro test portem

; ------ nvrat registr

INT088:  pop       ds
         pop       dx
         pop       ax
         iret

INT08    ENDP

; -----------------------------------------------------------------------------
;        obsluha INT 16h - test instalace
; -----------------------------------------------------------------------------

INT16    PROC      FAR

; ------ test, zda je program rezidentn

         cmp       ax,KLIC1
         jne       INT161
         cmp       bx,KLIC2
         jne       INT161
         cmp       cx,KLIC3
         jne       INT161
         cmp       dx,KLIC4
         jne       INT161
         push      cs
         pop       es                       ; ES <- segment programu
         mov       bx,KLIC5
         sti
         ret       2

; ------ jinak pokraovn pvodn obsluhou

INT161:  jmp       dword ptr cs:[Old16+KORIG] ; pokraovn v obsluze INT 16h

INT16    ENDP

RezidEn0 label     byte                     ; konec rezidentn sti bez myi

; -----------------------------------------------------------------------------
;        obsluha INT 33h
; -----------------------------------------------------------------------------

MPozice  dw        0                        ; uschovan pozice myi
MRadek   dw        0                        ; uschovan dek myi

INT33    PROC      FAR

         cmp       ax,3
         je        INT332
         cmp       ax,0bh
         je        INT335
INT331:  jmp       dword ptr cs:[Old33+KORIG] ; pokraovn v obsluze

INT332:  pushf
         call      dword ptr cs:[Old33+KORIG]

         cmp       cx,cs:[MPozice+KORIG]
         jne       INT333
         cmp       dx,cs:[MRadek+KORIG]
         je        INT334

INT333:  or        byte ptr cs:[Param+KORIG],bit2 ; poadavek rozsvcen
         mov       cs:[MPozice+KORIG],cx    ; schova pozice
         mov       cs:[MRadek+KORIG],dx     ; schova dku
INT334:  iret

INT335:  pushf
         call      dword ptr cs:[Old33+KORIG]

         or        dx,dx
         jnz       INT336
         jcxz      INT337

INT336:  or        byte ptr cs:[Param+KORIG],bit2 ; poadavek rozsvcen
INT337:  iret

INT33    ENDP

RezidEnd label     byte                     ; konec rezidentn sti, je-li my

; *****************************************************************************
;
;                               Start programu
;
; *****************************************************************************
;
; ------ zobrazen vodnho textu

Init:    mov       dx,offset UvTxt          ; vodn text
         call      DispTxt                  ; zobrazen vodnho textu

; ------ schova pkazovho dku

         mov       si,81h                   ; zatek pkazovho dku
         mov       di,offset Command        ; buffer pkazovho dku
         mov       cl,ds:[si-1]             ; dlka pkazovho dku
         mov       ch,0
         cld
         rep       movsb                    ; schova pkazovho dku
         mov       ds:[di],ch               ; oznaen konce pkazovho dku

; ------ posun programu dol

         mov       si,offset RezidBeg       ; zatek rezidentn sti
         mov       di,offset RezidBeg+KORIG ; nov adresa
         mov       cx,(offset(RezidEnd-RezidBeg)+1)/2 ; dlka (ve slovech)
         rep       movsw                    ; posun programu dol

; ------ schova adresy obsluhy INT 33h

         mov       ax,3533h
         int       21h                      ; poskytnut adresy INT 33h
         mov       word ptr ds:[Old33+KORIG],bx ; schova adresy INT 33h
         mov       word ptr ds:[Old33+2+KORIG],es

; ------ test, zda je program nainstalovn

         mov       ax,KLIC1
         mov       bx,KLIC2
         mov       cx,KLIC3
         mov       dx,KLIC4
         int       16h                      ; test instalace programu
         cmp       bx,KLIC5                 ; je program nainstalovn ?
         je        Init2                    ; je nainstalovn, v ES je adresa
         or        byte ptr ds:[Param+KORIG],bit7; pznak prvn instalace programu
         push      cs
         pop       es                       ; ES <- segment tohoto programu

; ------ test, zda je adresa INT 33h platn

         cmp       word ptr ds:[Old33+2+KORIG],70h; minimln adresa INT 33h
         jb        Init2                    ; adresa INT 33h neplatn, nen my
         cmp       word ptr ds:[Old33+KORIG],-1 ; neplatn offset -1 ?
         je        Init2                    ; adresa INT 33h neplatn, nen my

; ------ prvn instalace - test, zda je nainstalovn ovlada myi

         xor       ax,ax
         int       33h                      ; test instalace ovladae myi
         inc       ax                       ; je ovlada myi nainstalovn ?
         jnz       Init2                    ; nen nainstalovn
         or        byte ptr ds:[Param+KORIG],bit5 ; pznak ovladae myi

; ------ rozbor pkazovho dku (ES=segment rezidentnho programu)

Init2:   call      Rozbor                   ; rozbor

; ------ korekce daje doby 0

         pushf
         cmp       word ptr es:[Timer0+KORIG],18
         jae       Init222
         mov       word ptr es:[Timer0+KORIG],18
         mov       word ptr es:[Timer+KORIG],18
Init222: popf
         jnc       Init3                    ; zadn parametr OK
         mov       dx,offset HelpTxt        ; text npovdy

; ------ chyba - zobrazen textu chyby

Chyba:   call      DispTxt                  ; zobrazen chybovho hlen
         int       20h

; ------ test, zda je poadovno odinstalovn

Init3:   test      byte ptr ds:[Param+KORIG],bit6 ; poadovno odinstalovn ?
         jz        Init4                    ; nen poadovno odinstalovn

; ------ test, zda je program nainstalovn

         mov       dx,offset NeniTxt        ; text - nen nainstalovn
         test      byte ptr ds:[Param+KORIG],bit7 ; je nainstalovn ?
         jnz       Chyba                    ; chyba - nen nainstalovn

; ------ test, zda lze odinstalovat

         call      TestDIns                 ; test, zda lze odinstalovat
         mov       dx,offset NelzeTxt       ; text - nelze odinstalovat
         jc        Chyba                    ; chyba - nelze odinstalovat

; ------ odinstalovn programu z pamti

         call      DeInst                   ; odinstalovn programu z pamti
         mov       dx,offset DInstTxt       ; text - byl odinstalovn
         jmp       Chyba                    ; hlen o odinstalovn

; ------ test, zda je program ji nainstalovn

Init4:   test      byte ptr ds:[Param+KORIG],bit7 ; je to prvn instalace ?
         jnz       Init5                    ; je to prvn instalace

; ------ zobrazen hlen o stavu a konec

         call      DispStav                 ; zobrazen hlen o stavu
         int       20h                      ; konec programu

; ------ instalace obsluhy INT 23h (aby nebyla instalace peruena)

Init5:   mov       dx,offset Int23          ; pracovn obsluha INT 23h
         mov       ax,2523h
         int       21h                      ; instalace INT 23h

; ------ schova adresy INT 08h

         mov       ax,3508h
         int       21h                      ; poskytnut adresy INT 08h
         mov       word ptr ds:[Old08+KORIG],bx ; schova adresy INT 08h
         mov       word ptr ds:[Old08+2+KORIG],es

; ------ schova adresy INT 09h

         mov       ax,3509h
         int       21h                      ; poskytnut adresy INT 09h
         mov       word ptr ds:[Old09+KORIG],bx ; schova adresy INT 09h
         mov       word ptr ds:[Old09+2+KORIG],es

; ------ schova adresy INT 16h

         mov       ax,3516h
         int       21h                      ; poskytnut adresy INT 16h
         mov       word ptr ds:[Old16+KORIG],bx ; schova adresy INT 16h
         mov       word ptr ds:[Old16+2+KORIG],es

; ------ instalace obsluhy INT 08h

         mov       dx,offset Int08+KORIG
         mov       ax,2508h
         int       21h                      ; instalace obsluhy INT 08h

; ------ instalace obsluhy INT 09h

         mov       dx,offset Int09+KORIG
         mov       ax,2509h
         int       21h                      ; instalace obsluhy INT 09h

; ------ instalace obsluhy INT 16h

         mov       dx,offset Int16+KORIG
         mov       ax,2516h
         int       21h                      ; instalace obsluhy INT 16h

; ------ instalace obsluhy INT 33h

         test      byte ptr ds:[Param+KORIG],bit5 ; je ovlada myi ?
         jz        Init6                    ; nen ovlada myi
         mov       dx,offset Int33+KORIG
         mov       ax,2533h
         int       21h                      ; instalace obsluhy INT 33h

; ------ uvolnn segmentu prosted

Init6:   mov       es,ds:[2ch]              ; segment prosted
         mov       ah,49h
         int       21h                      ; uvolnn segmentu prosted

; ------ hlen o nainstalovn

         mov       dx,offset InstTxt
         call      DispTxt

; ------ hlen o stavu programu

         push      cs
         pop       es
         call      DispStav                 ; zobrazen stavu programu

; ------ instalace programu do pamti

         mov       dx,offset RezidEnd+KORIG ; konec, je-li my
         test      byte ptr ds:[Param+KORIG],bit5 ; je nainstalovna my ?
         jnz       Init8                    ; je nainstalovna my
         mov       dx,offset RezidEn0+KORIG ; konec, nen-li my
Init8:   int       27h                      ; instalace do pamti

; -----------------------------------------------------------------------------
;        pechodn obsluha INT 23h
; -----------------------------------------------------------------------------

Int23:   iret

; -----------------------------------------------------------------------------
;        zobrazen hlen o stavu programu (ES=rezidentn program)
; -----------------------------------------------------------------------------

DispStav PROC      NEAR

; ------ zobrazen vodu hlen

         mov       dx,offset AktTxt
         call      DispTxt                  ; zobrazen vodn sti hlen

; ------ hlen, zda je aktivn

         mov       dx,offset Akt1Txt        ; text - nen aktivn
         test      byte ptr es:[Param+KORIG],bit0 ; je program aktivn ?
         jz        DispStv1                 ; program nen aktivn
         mov       dx,offset Akt2txt        ; text - je aktivn
DispStv1:call      DispTxt

; ------ zobrazen potu minut

         mov       ax,es:[Timer0+KORIG]     ; nastaven doba
         xor       dx,dx
         mov       bx,1092                  ; poet impuls
         div       bx                       ; vpoet potu minut
         call      DispNum                  ; zobrazen potu minut

; ------ zobrazen potu sekund

         xchg      ax,dx
         mov       dx,offset Akt3Txt
         or        ax,ax                    ; jsou sekundy ?
         jz        DispStv2                 ; nejsou sekundy
         mov       dx,offset Akt4Txt
         call      DispTxt
         xor       dx,dx
         mov       bx,18
         div       bx                       ; vpoet potu sekund
         call      DispNum                  ; zobrazen potu sekund

; ------ zobrazen zbytku textu

         mov       dx,offset Akt5Txt
DispStv2:call      DispTxt                  ; zobrazen zbytku textu
         ret

DispStav ENDP

; -----------------------------------------------------------------------------
;        zobrazen sla AX
; -----------------------------------------------------------------------------

DispNum  PROC      NEAR

; ------ schova registr

         push      ax
         push      bx
         push      cx
         push      dx

; ------ dekdovn jedn slice

         xor       cx,cx                    ; ta znak
         mov       bx,10                    ; dlitel
DispNum1:xor       dx,dx                    ; DX <- 0
         div       bx                       ; vpoet jedn slice
         add       dl,"0"                   ; korekce na znak ASCII
         push      dx                       ; schova slice do zsobnku
         inc       cx                       ; zven tae slic
         or        ax,ax                    ; je ji 0 ?
         jnz       DispNum1                 ; nen jet 0

; ------ zobrazen sla

DispNum2:pop       dx
         mov       ah,2
         int       21h                      ; zobrazen slice
         loop      DispNum2                 ; dal slice

; ------ nvrat registr

         pop       dx
         pop       cx
         pop       bx
         pop       ax
         ret

DispNum  ENDP

; -----------------------------------------------------------------------------
;        zobrazen textu DS:DX
; -----------------------------------------------------------------------------

DispTxt  PROC      NEAR

         push      ax
         mov       ah,9
         int       21h
         pop       ax
         ret

DispTxt  ENDP

; -----------------------------------------------------------------------------
;        test, zda lze program odinstalovat (ES=rezidentn st)
; -----------------------------------------------------------------------------

TestDIns PROC      NEAR

; ------ schova registr

         push      es
         mov       cx,es

; ------ test, zda je nainstalovna obsluha INT 33h

         test      byte ptr es:[Param+KORIG],bit5 ; je ovlada myi ?
         jz        TestDIn2                 ; nen ovlada myi

; ------ test vektoru INT 33h

         mov       ax,3533h
         int       21h                      ; poskytnut adresy INT 33h
         mov       ax,es
         cmp       ax,cx
         jne       TestDIn8

; ------ test vektoru INT 16h

TestDIn2:mov       ax,3516h
         int       21h                      ; poskytnut adresy INT 16h
         mov       ax,es
         cmp       ax,cx
         jne       TestDIn8

; ------ test vektoru INT 09h

         mov       ax,3509h
         int       21h                      ; poskytnut adresy INT 09h
         mov       ax,es
         cmp       ax,cx
         jne       TestDIn8

; ------ test vektoru INT 08h

         mov       ax,3508h
         int       21h                      ; poskytnut adresy INT 08h
         mov       ax,es
         cmp       ax,cx
         je        TestDIn9                 ; lze odinstalovat OK

; ------ nvrat registr

TestDIn8:stc                                ; pznak chyby - nelze odinstalovat
TestDIn9:pop       es
         ret

TestDIns ENDP

; -----------------------------------------------------------------------------
;        odinstalovn programu z pamti (ES=rezidentn st)
; -----------------------------------------------------------------------------

DeInst   PROC      NEAR

; ------ schova registr

         cli
         push      ds

; ------ nvrat INT 08h

         lds       dx,es:[Old08+KORIG]
         mov       ax,2508h
         int       21h                      ; nvrat adresy INT 08h

; ------ nvrat INT 09h

         lds       dx,es:[Old09+KORIG]
         mov       ax,2509h
         int       21h                      ; nvrat adresy INT 09h

; ------ nvrat INT 16h

         lds       dx,es:[Old16+KORIG]
         mov       ax,2516h
         int       21h                      ; nvrat adresy INT 16h

; ------ nvrat INT 33h

         test      byte ptr es:[Param+KORIG],bit5 ; je ovlada myi ?
         jz        DeInst2                  ; nen ovlada myi
         lds       dx,es:[Old33+KORIG]
         mov       ax,2533h
         int       21h                      ; nvrat adresy INT 33h

; ------ uvolnn segmentu programu

DeInst2: mov       ah,49h
         int       21h                      ; uvolnn segmentu programu

; ------ rozsvcen displeje

         call      Rozsvit                  ; rozsvcen displeje

; ------ nvrat registr

         pop       ds
         sti
         ret

DeInst   ENDP

; -----------------------------------------------------------------------------
;        Rozbor pkazovho dku (ES=segment programu)
; -----------------------------------------------------------------------------

Rozbor   PROC      NEAR

         mov       si,offset Command        ; buffer pkazovho dku

; ------ naten znaku parametru

Rozbor1: call      RozbSpc                  ; vyputn mezer
         call      RozbChr                  ; naten znaku
         jnc       Rozbor2                  ; je platn znak
         clc                                ; pznak operace OK
         ret

; ------ ignorovn znaku "/"

Rozbor2: cmp       al,"/"
         je        Rozbor1                  ; znak "/" se ignoruje

; ------ parametr "N" - ztmavovn neaktivn

         cmp       al,"N"
         jne       Rozbor3
         cli
         and       byte ptr es:[Param+KORIG],not bit0+bit1+bit2 ; vypnut funkce
         call      Rozsvit                  ; rozsvcen displeje
         sti
         jmp       short Rozbor1

; ------ parametr "A" - ztmavovn aktivn

Rozbor3: cmp       al,"A"
         jne       Rozbor4
         cli
         or        byte ptr es:[Param+KORIG],bit0 ; zapnut funkce
         mov       ax,es:[Timer0+KORIG]
         mov       es:[Timer+KORIG],ax      ; inicializace tae
         sti
         jmp       short Rozbor1

; ------ parametr "X" - okamit ztmaven

Rozbor4: cmp       al,"X"
         jne       Rozbor5
         cli
         and       byte ptr es:[Param+KORIG],not bit3 ; zruen poad.rozsvcen
         or        byte ptr es:[Param+KORIG],bit0+bit1 ; zapnut + ztmaven
         sti
         jmp       short Rozbor1

; ------ parametr "!" - odinstalovn programu z pamti

Rozbor5: cmp       al,"!"
         jne       Rozbor6
         or        byte ptr ds:[Param+KORIG],bit6 ; poadavek odinstalovn
Rozbor11:jmp       short Rozbor1

; ------ seln parametr

Rozbor6: dec       si                       ; nvrat znaku
         call      RozbNum                  ; vstup sla
         jc        Rozbor9                  ; nen platn slo

; ------ omezen maximln poadovan doby na 60 minut

         cmp       ax,60                    ; maximln doba
         jb        Rozbor62                 ; slo je OK
         mov       ax,60                    ; omezen sla

; ------ vpoet nov konstanty

Rozbor62:mov       bx,1092                  ; nsobitel
         mul       bx                       ; vpoet sla

; ------ nastaven konstanty tae

Rozbor64:mov       es:[Timer0+KORIG],ax     ; nov konstanta pro ztmvn
         mov       es:[Timer+KORIG],ax      ; nov konstanta pro aktivn ta

; ------ test, zda jsou zadny sekundy

         call      RozbSpc
         jc        Rozbor11
         cmp       al,":"
         jne       Rozbor11
         call      RozbChr
         call      RozbNum                  ; vstup zadn sekund
         jc        Rozbor9

; ------ omezen potu sekund

         cmp       ax,59
         jb        Rozbor65
         mov       ax,59
Rozbor65:mov       bx,18
         mul       bx
         mov       bx,es:[Timer0+KORIG]
         add       ax,bx
         jc        Rozbor66
         cmp       ax,1092*60
         jb        Rozbor67
Rozbor66:mov       ax,1092*60
Rozbor67:mov       es:[Timer0+KORIG],ax     ; nov konstanta pro ztmvn
         mov       es:[Timer+KORIG],ax      ; nov konstanta pro aktivn ta
         jmp       short Rozbor11

Rozbor9: ret

Rozbor   ENDP

; -----------------------------------------------------------------------------
;        rozbor zadn selnho parametru -> AX
; -----------------------------------------------------------------------------

RozbNum  PROC      NEAR

; ------ schova registr

         push      dx

; ------ test, zda je zadno slo

         xor       dx,dx                    ; stada sla
         call      RozbSpc                  ; vyputn mezer
         call      RozbNm                   ; prvn slice
         jc        RozbNum9                 ; nen zadno slo

; ------ vynsoben stadae 10x

RozbNum2:push      ax
         mov       ax,10
         mul       dx                       ; vynsoben stadae
         or        dx,dx                    ; je peteen sla ?
         jz        RozbNum3                 ; nen peteen sla
         mov       ax,-1                    ; omezen sla
RozbNum3:pop       dx                       ; naten slo

; ------ piten naten slice

         mov       dh,0
         add       dx,ax                    ; nov hodnota stadae
         jnc       RozbNum4                 ; nen peteen sla
         mov       dx,-1                    ; omezen sla

; ------ dal slice

RozbNum4:call      RozbNm                   ; naten slice
         jnc       RozbNum2                 ; je dal slice
         xchg      ax,dx                    ; AX <- naten slo
         clc                                ; pznak operace OK

; ------ nvrat registr

RozbNum9:pop       dx
         ret

RozbNum  ENDP

; -----------------------------------------------------------------------------
;        rozbor jedn slice
; -----------------------------------------------------------------------------

RozbNm   PROC      NEAR

         call      RozbChr                  ; naten znaku
         jc        RozbNm9                  ; nen dal znak
         cmp       al,"0"
         jb        RozbNm8
         cmp       al,"9"
         ja        RozbNm8
         sub       al,"0"
         ret

RozbNm8: dec       si
         stc                                ; pznak neplatnho znaku
RozbNm9: ret

RozbNm   ENDP

; -----------------------------------------------------------------------------
;        vyputn mezer z pkazovho dku
; -----------------------------------------------------------------------------

RozbSpc  PROC      NEAR

         call      RozbChr
         jc        RozbSpc9
         je        RozbSpc
         dec       si

RozbSpc9:ret

RozbSpc  ENDP

; -----------------------------------------------------------------------------
;        vstup znaku z pkazovho dku
; -----------------------------------------------------------------------------

RozbChr  PROC      NEAR

         cld
         lodsb

; ------ nhrada tabeltoru mezerou

         cmp       al,9
         jne       RozbChr2
         mov       al," "

; ------ konverze na velk psmeno

RozbChr2:cmp       al,"a"
         jb        RozbChr3
         cmp       al,"z"
         ja        RozbChr3
         sub       al,32

; ------ test, zda je konec textu

RozbChr3:cmp       al," "
         jae       RozbChr4
         dec       si

RozbChr4:ret

RozbChr  ENDP

; -----------------------------------------------------------------------------
;        rozsvcen displeje
; -----------------------------------------------------------------------------

Rozsvit  PROC      NEAR

         push      ax
         push      ds
         xor       ax,ax                    ; AX <- 0
         mov       ds,ax                    ; DS <- 0
         mov       dx,ds:[463h]             ; bzov dic adresa displeje
         add       dl,4
         mov       al,ds:[465h]             ; nastaven portu 3x8h
         or        al,8
         out       dx,al                    ; povolen zobrazen
         add       dl,2                     ; adresa stavovho portu displeje
         in        al,dx                    ; synchronizace nslednosti
         mov       dl,0c0h                  ; adresa portu palet
         mov       al,20h
         out       dx,al                    ; zapnut videosignlu
         pop       ds
         pop       ax
         ret

Rozsvit  ENDP

; *****************************************************************************
;
;                                   Data
;
; *****************************************************************************

UvTxt    db        'DARKER V1.0 - ztmavovac displeje; (c) Miroslav Nemecek',13,10,'$'
HelpTxt  db        'Zadejte:    N ....... ztmavovani je neaktivni',13,10
         db        '            A ....... ztmavovani je aktivni (implicitne)',13,10
         db        '            cislo ... doba pro ztmaveni 1 az 60 minut (implicitne 5 minut)',13,10
         db        '            min:sek . doba pro ztmaveni ve tvaru minuty:sekundy',13,10
         db        '                       (v rozsahu 1 sekunda az 60 minut)',13,10
         db        '            X ....... okamzite ztmaveni displeje',13,10
         db        '            ! ....... odinstalovani programu z pameti',13,10
         db        '$'

InstTxt  db        'Program byl nainstalovan do pameti.',13,10,'$'
AktTxt   db        'Ztmavovani je $'
Akt1Txt  db        'NE'
Akt2Txt  db        'AKTIVNI, nastavena doba $'
Akt3Txt  db        ' minut.',13,10,'$'
Akt4Txt  db        ' minut, $'
Akt5Txt  db        ' sekund.',13,10,'$'

DInstTxt db        'Program byl odinstalovan z pameti.',13,10,'$'

NeniTxt  db        'Program nelze odinstalovat, nebyl dosud nainstalovan.',13,10,'$'
NelzeTxt db        'Program nelze odinstalovat, je nutno nejdrive',13,10
         db        'odinstalovat programy nainstalovane pozdeji.',13,10,'$'

Command  db        128 dup(?)               ; buffer pkazovho dku

Code     ENDS
         END       Start
